function schurmat = HKM_schur_LR_structure(U,V,extra,L,R,A,M,negated,negated_disc,epsilon,delta,numpos,xindicies,Pindicies)


persistent At
persistent par
persistent blk

global nnzschur nzlistschur

nnzschurTEMP = nnzschur;
nzlistschurTEMP = nzlistschur;

useINPLACE = 1;

if isempty(U)
    
    
    if ~isempty(M)
        par = extra.par;
        par.iter = 1;
        blk{1,1} = 's';
        blk{1,2} = size(M{1},1);
        At = svec(blk,M);
        p = length(M);
        schur = sparse(length(M),length(M));
        par.numcolAt = length(M);
        [Ataux,C,X,Z,par.permA,par.permZ] = sortA(blk,{ones(size(At{1}))},{ones(size(M{1},1))},zeros(p,1),{ones(size(M{1},1))},{ones(size(M{1},1))});
        [par.isspA,par.nzlistA,par.nzlistAsum,par.isspAy,par.nzlistAy] = nzlist(blk,At,par);
    else
        
    end
    schurmat = [];
    return
end

U = full(U);
V = full(V);
p = length(M);

ntot = 0;
for i = 1:length(L)
    ntot = ntot + length(numpos{i});
end

schurmat = zeros(ntot+p);



schurmatindex = zeros(length(L)+1,1);
schurmatindex(1) = 1;
for k = 2:(length(L)+1)
    schurmatindex(k) = schurmatindex(k-1)+length(numpos{k-1});
end

for i = 1:length(L)
    
    Stotal = 0;
    
    % Pi w.r.t. Pi, continous case
    for j = 1:length(L{i})
        [Rit_U_Ri Rit_V_Ri Rit_U_Li Lit_U_Li Rit_V_Li Lit_V_Li] = precomputer_schur_same(U,V,L{i}{j},R{i}{j});
        
        if ~useINPLACE
            
            
            S = compute_LR_schur_HKMMEX_structure(size(L{i}{j},2),           size(R{i}{j},2), ...
                length(numpos{i}),...
                Rit_U_Ri,...
                Rit_V_Ri,...
                Rit_U_Li,...
                Lit_U_Li,...
                Rit_V_Li,...
                Lit_V_Li,...
                epsilon{i},...
                delta{i},...
                numpos{i});
            
            schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)+S;
            
            
            
        else
            
            compute_LR_schur_HKMMEX_structure_INPLACE(size(L{i}{j},2), size(R{i}{j},2), ...
                length(numpos{i}),...
                Rit_U_Ri,...
                Rit_V_Ri,...
                Rit_U_Li,...
                Lit_U_Li,...
                Rit_V_Li,...
                Lit_V_Li,...
                epsilon{i},...
                delta{i},...
                numpos{i},uint32(schurmatindex(i):schurmatindex(i+1)-1),length(schurmat),schurmat);
        end
        
        
        for k = j+1:length(L{i})
            [Rit_U_Lj Rjt_V_Li Rit_U_Rj Ljt_V_Li Lit_U_Lj Rjt_V_Ri Lit_U_Rj Ljt_V_Ri] = precomputer_schur_different(U,V,L{i}{j},L{i}{k},R{i}{j},R{i}{k});
            
            if xor(negated{i}(j),negated{i}(k)) == 1
                schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)- ...
                    compute_LR_schur_same_HKMMEX_structure(size(L{i}{j},2),...
                    size(R{i}{j},2),...
                    length(numpos{i}),...
                    Rit_U_Lj,...
                    Rjt_V_Li,...
                    Rit_U_Rj,...
                    Ljt_V_Li,...
                    Lit_U_Lj,...
                    Rjt_V_Ri,...
                    Lit_U_Rj,...
                    Ljt_V_Ri,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
                
            else
                if ~useINPLACE
                    S=compute_LR_schur_same_HKMMEX_structure(size(L{i}{j},2),...
                        size(R{i}{j},2),...
                        length(numpos{i}),...
                        Rit_U_Lj,...
                        Rjt_V_Li,...
                        Rit_U_Rj,...
                        Ljt_V_Li,...
                        Lit_U_Lj,...
                        Rjt_V_Ri,...
                        Lit_U_Rj,...
                        Ljt_V_Ri,...
                        epsilon{i},...
                        delta{i},...
                        numpos{i});
                    
                    % Stotal = Stotal + S;
                    
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                        schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)+S;
                else
                    compute_LR_schur_same_HKMMEX_structure_INPLACE(size(L{i}{j},2),...
                        size(R{i}{j},2),...
                        length(numpos{i}),...
                        Rit_U_Lj,...
                        Rjt_V_Li,...
                        Rit_U_Rj,...
                        Ljt_V_Li,...
                        Lit_U_Lj,...
                        Rjt_V_Ri,...
                        Lit_U_Rj,...
                        Ljt_V_Ri,...
                        epsilon{i},...
                        delta{i},...
                        numpos{i},uint32(schurmatindex(i):schurmatindex(i+1)-1),length(schurmat),schurmat);
                    
                    
                    
                end
            end
            
            [Rit_U_Lj Rjt_V_Li Rit_U_Rj Ljt_V_Li Lit_U_Lj Rjt_V_Ri Lit_U_Rj Ljt_V_Ri] = precomputer_schur_different(U,V,L{i}{k},L{i}{j},R{i}{k},R{i}{j});
            if xor(negated{i}(j),negated{i}(k)) == 1
                schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)- ...
                    compute_LR_schur_same_HKMMEX_structure(size(L{i}{j},2),...
                    size(R{i}{j},2),...
                    length(numpos{i}),...
                    Rit_U_Lj,...
                    Rjt_V_Li,...
                    Rit_U_Rj,...
                    Ljt_V_Li,...
                    Lit_U_Lj,...
                    Rjt_V_Ri,...
                    Lit_U_Rj,...
                    Ljt_V_Ri,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
                
            else
                if ~useINPLACE
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                        schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)+compute_LR_schur_same_HKMMEX_structure(size(L{i}{j},2),...
                        size(R{i}{j},2),...
                        length(numpos{i}),...
                        Rit_U_Lj,...
                        Rjt_V_Li,...
                        Rit_U_Rj,...
                        Ljt_V_Li,...
                        Lit_U_Lj,...
                        Rjt_V_Ri,...
                        Lit_U_Rj,...
                        Ljt_V_Ri,...
                        epsilon{i},...
                        delta{i},...
                        numpos{i});
                else
                    compute_LR_schur_same_HKMMEX_structure_INPLACE(size(L{i}{j},2),...
                        size(R{i}{j},2),...
                        length(numpos{i}),...
                        Rit_U_Lj,...
                        Rjt_V_Li,...
                        Rit_U_Rj,...
                        Ljt_V_Li,...
                        Lit_U_Lj,...
                        Rjt_V_Ri,...
                        Lit_U_Rj,...
                        Ljt_V_Ri,...
                        epsilon{i},...
                        delta{i},...
                        numpos{i},uint32(schurmatindex(i):schurmatindex(i+1)-1),length(schurmat),schurmat);
                end
            end
        end
    end
    
    % Pi w.r.t. Pj, continous case
    for k = i+1:length(L)
        for j = 1:length(L{i})
            for l = 1:length(L{k})
                [Rit_U_Lj Rjt_V_Li Rit_U_Rj Ljt_V_Li Lit_U_Lj Rjt_V_Ri Lit_U_Rj Ljt_V_Ri] = precomputer_schur_different(U,V,L{i}{j},L{k}{l},R{i}{j},R{k}{l});
                
                if xor(negated{i}(j),negated{k}(l)) == 1
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) = ...
                        schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) -...
                        compute_LR_schur_different_HKMMEX_structure(size(L{i}{j},2),...
                        size(R{i}{j},2),...
                        size(L{k}{l},2),...
                        size(R{k}{l},2),...
                        length(numpos{i}),...
                        length(numpos{k}),...
                        Rit_U_Lj,...
                        Rjt_V_Li,...
                        Rit_U_Rj,...
                        Ljt_V_Li,...
                        Lit_U_Lj,...
                        Rjt_V_Ri,...
                        Lit_U_Rj,...
                        Ljt_V_Ri,...
                        epsilon{i},...
                        delta{i},...
                        numpos{i},...
                        epsilon{k},...
                        delta{k},...
                        numpos{k});
                else
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) = ...
                        schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) +...
                        compute_LR_schur_different_HKMMEX_structure(size(L{i}{j},2),...
                        size(R{i}{j},2),...
                        size(L{k}{l},2),...
                        size(R{k}{l},2),...
                        length(numpos{i}),...
                        length(numpos{k}),...
                        Rit_U_Lj,...
                        Rjt_V_Li,...
                        Rit_U_Rj,...
                        Ljt_V_Li,...
                        Lit_U_Lj,...
                        Rjt_V_Ri,...
                        Lit_U_Rj,...
                        Ljt_V_Ri,...
                        epsilon{i},...
                        delta{i},...
                        numpos{i},...
                        epsilon{k},...
                        delta{k},...
                        numpos{k});
                end
            end
        end
        schurmat(schurmatindex(k):schurmatindex(k+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1)';
    end
    % Pi w.r.t Pi, discrete case
    for j = 1:length(A{i})
        [Ai_U_Ait Ai_V_Ait] = precomputer_schur_same_disc(U,V,A{i}{j});
        if 0
            schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)+...
                compute_AtA_schur_HKMMEX_structure(   size(A{i}{j},1), ...
                length(numpos{i}),...
                Ai_U_Ait,...
                Ai_V_Ait,...
                epsilon{i},...
                delta{i},...
                numpos{i});
        else
            compute_AtA_schur_HKMMEX_structure_INPLACE(size(A{i}{j},1), ...
                length(numpos{i}),...
                Ai_U_Ait,...
                Ai_V_Ait,...
                epsilon{i},...
                delta{i},...
                numpos{i},uint32(schurmatindex(i):schurmatindex(i+1)-1),length(schurmat),schurmat);
        end
        for k = j+1:length(A{i})
            [Ai_U_Ajt Aj_V_Ait] = precomputer_schur_different_disc(U,V,A{i}{j},A{i}{k});
            
            if xor(negated_disc{i}(j),negated_disc{i}(k)) == 1
                schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)-...
                    compute_AtA_schur_same_HKMMEX_structure(   size(A{i}{j},1), ...
                    length(numpos{i}),...
                    Ai_U_Ajt,...
                    Aj_V_Ait,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
            else
                schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)+...
                    compute_AtA_schur_same_HKMMEX_structure(   size(A{i}{j},1), ...
                    length(numpos{i}),...
                    Ai_U_Ajt,...
                    Aj_V_Ait,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
            end
            
            [Ai_U_Ajt Aj_V_Ait] = precomputer_schur_different_disc(U,V,A{i}{k},A{i}{j});
            if xor(negated_disc{i}(j),negated_disc{i}(k)) == 1
                schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)-...
                    compute_AtA_schur_same_HKMMEX_structure(   size(A{i}{j},1), ...
                    length(numpos{i}),...
                    Ai_U_Ajt,...
                    Aj_V_Ait,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
            else
                schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)+...
                    compute_AtA_schur_same_HKMMEX_structure(   size(A{i}{j},1), ...
                    length(numpos{i}),...
                    Ai_U_Ajt,...
                    Aj_V_Ait,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
            end
        end
    end
    
    % Pi w.r.t Pj, discrete case
    for k = i+1:length(A)
        for j = 1:length(A{i})
            for l = 1:length(A{k})
                
                [Ai_U_Ajt Aj_V_Ait] = precomputer_schur_different_disc(U,V,A{i}{j},A{k}{l});
                if xor(negated_disc{i}(j),negated_disc{k}(l)) == 1
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) = ...
                        schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) -...
                        compute_AtA_schur_different_HKMMEX_structure(size(A{i}{j},1),...
                        size(A{k}{l},1),...
                        length(numpos{i}),...
                        length(numpos{k}),...
                        Ai_U_Ajt,...
                        Aj_V_Ait,...
                        epsilon{i},...
                        delta{i},...
                        numpos{i},...
                        epsilon{k},...
                        delta{k},...
                        numpos{k});
                else
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) = ...
                        schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) +...
                        compute_AtA_schur_different_HKMMEX_structure(size(A{i}{j},1),...
                        size(A{k}{l},1),...
                        length(numpos{i}),...
                        length(numpos{k}),...
                        Ai_U_Ajt,...
                        Aj_V_Ait,...
                        epsilon{i},...
                        delta{i},...
                        numpos{i},...
                        epsilon{k},...
                        delta{k},...
                        numpos{k});
                end
            end
        end
        schurmat(schurmatindex(k):schurmatindex(k+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1)';
    end
    
    % Pi w.r.t Pi, mixed case
    for j = 1:length(A{i})
        for k = 1:length(L{i})
            [A_U_R A_V_L A_V_R A_U_L] = precomputer_schur_mixed_disc(U,V,L{i}{k},R{i}{k},A{i}{j});
            
            if xor(negated_disc{i}(j),negated{i}(k)) == 1
                schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)- ...
                    compute_LR_AtA_schur_same_HKMMEX_structure(size(A{i}{j},1),...
                    length(numpos{i}),...
                    A_U_R,...
                    A_V_L,...
                    A_V_R,...
                    A_U_L,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
                
            else
                schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1)+ ...
                    compute_LR_AtA_schur_same_HKMMEX_structure(size(A{i}{j},1),...
                    length(numpos{i}),...
                    A_U_R,...
                    A_V_L,...
                    A_V_R,...
                    A_U_L,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
                
            end
            
            
            
        end
    end
    
    % Pi w.r.t Pj, mixed case
    for k = i+1:length(A)
        for j = 1:length(L{i})
            for l = 1:length(A{k})
                [A_U_R A_V_L A_V_R A_U_L] = precomputer_schur_mixed_disc(U,V,L{i}{j},R{i}{j},A{k}{l});
                if xor(negated{i}(j),negated_disc{k}(l)) == 1
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) = ...
                        schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) - ...
                        compute_LR_AtA_schur_different_HKMMEX_structure(size(A{k}{l},1),...
                        length(numpos{i}),...
                        length(numpos{k}),...
                        A_U_R,...
                        A_V_L,...
                        A_V_R,...
                        A_U_L,...
                        epsilon{i},...
                        delta{i},...
                        numpos{i},...
                        epsilon{k},...
                        delta{k},...
                        numpos{k});
                else
                    schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) = ...
                        schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) + ...
                        compute_LR_AtA_schur_different_HKMMEX_structure(size(A{k}{l},1),...
                        length(numpos{i}),...
                        length(numpos{k}),...
                        A_U_R,...
                        A_V_L,...
                        A_V_R,...
                        A_U_L,...
                        epsilon{i},...
                        delta{i},...
                        numpos{i},...
                        epsilon{k},...
                        delta{k},...
                        numpos{k});
                end
            end
        end
        
        
        schurmat(schurmatindex(k):schurmatindex(k+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1)';
    end
    % Pi w.r.t Pj, mixed case, continued
    for k = 1:i-1
        for j = 1:length(L{i})
            for l = 1:length(A{k})
                [A_U_R A_V_L A_V_R A_U_L] = precomputer_schur_mixed_disc(U,V,L{i}{j},R{i}{j},A{k}{l});
                if xor(negated{i}(j),negated_disc{k}(l)) == 1
                    schurmat(schurmatindex(k):schurmatindex(k+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                        schurmat(schurmatindex(k):schurmatindex(k+1)-1,schurmatindex(i):schurmatindex(i+1)-1) - ...
                        compute_AtA_LR_schur_different_HKMMEX_structure(size(A{k}{l},1),...
                        length(numpos{k}),...
                        length(numpos{i}),...
                        A_U_R,...
                        A_V_L,...
                        A_V_R,...
                        A_U_L,...
                        epsilon{k},...
                        delta{k},...
                        numpos{k},...
                        epsilon{i},...
                        delta{i},...
                        numpos{i});
                else
                    schurmat(schurmatindex(k):schurmatindex(k+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
                        schurmat(schurmatindex(k):schurmatindex(k+1)-1,schurmatindex(i):schurmatindex(i+1)-1) + ...
                        compute_AtA_LR_schur_different_HKMMEX_structure(size(A{k}{l},1),...
                        length(numpos{k}),...
                        length(numpos{i}),...
                        A_U_R,...
                        A_V_L,...
                        A_V_R,...
                        A_U_L,...
                        epsilon{k},...
                        delta{k},...
                        numpos{k},...
                        epsilon{i},...
                        delta{i},...
                        numpos{i});
                end
            end
        end
        schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(k):schurmatindex(k+1)-1) = schurmat(schurmatindex(k):schurmatindex(k+1)-1,schurmatindex(i):schurmatindex(i+1)-1)';
    end
    
    %schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1) = ...
    %     schurmat(schurmatindex(i):schurmatindex(i+1)-1,schurmatindex(i):schurmatindex(i+1)-1);
    
end


% % Compute the schurmat for P-variables with respect to x variables
schurmatxp = zeros(ntot,p);
for k = 1:p;
    UMkV = U*M{k}*V;
    for i = 1:length(L)
        % Continous case
        for j = 1:length(L{i})
            RitUMVLi = R{i}{j}'*UMkV*L{i}{j};
            LitUMVRi = L{i}{j}'*UMkV*R{i}{j};
            
            if negated{i}(j);
                schurmatxp(schurmatindex(i):schurmatindex(i+1)-1,k) = schurmatxp(schurmatindex(i):schurmatindex(i+1)-1,k)-...
                    compute_LR_x_schur_HKMMEX_structure(size(L{i}{j},2), ...
                    size(R{i}{j},2), ...
                    length(numpos{i}),...
                    RitUMVLi,...
                    LitUMVRi,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
            else
                schurmatxp(schurmatindex(i):schurmatindex(i+1)-1,k) =  schurmatxp(schurmatindex(i):schurmatindex(i+1)-1,k)+...
                    compute_LR_x_schur_HKMMEX_structure(size(L{i}{j},2), ...
                    size(R{i}{j},2), ...
                    length(numpos{i}),...
                    RitUMVLi,...
                    LitUMVRi,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
            end
        end
        % Discrete case
        for j = 1:length(A{i})
            AUMkVAt = A{i}{j}*UMkV*A{i}{j}';
            
            if negated_disc{i}(j)
                schurmatxp(schurmatindex(i):schurmatindex(i+1)-1,k) = schurmatxp(schurmatindex(i):schurmatindex(i+1)-1,k)-...
                    compute_AtA_x_schur_HKMMEX_structure(size(A{i}{j},1), ...
                    length(numpos{i}),...
                    AUMkVAt,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
                
                
                
            else
                schurmatxp(schurmatindex(i):schurmatindex(i+1)-1,k) = schurmatxp(schurmatindex(i):schurmatindex(i+1)-1,k)+...
                    compute_AtA_x_schur_HKMMEX_structure(size(A{i}{j},1), ...
                    length(numpos{i}),...
                    AUMkVAt,...
                    epsilon{i},...
                    delta{i},...
                    numpos{i});
            end
        end
        
    end
end

schurmat(schurmatindex(end):end,1:ntot) = schurmatxp';
schurmat(1:ntot,schurmatindex(end):end) = schurmatxp;


% Compute the schurmat for the unstructured x-variables (using built in
% SDPT3 function).
if 0
    if p > 0
        schurmatxx = sparse(p,p);
        schurmatxx = schurmat_sblk(blk,At,par,schurmatxx,1,{U},{V});
        schurmat(schurmatindex(end):end,schurmatindex(end):end) = schurmatxx;
    end
    
    % Hmm...
    if ~all(diag(schurmat))
        index = find(diag(schurmat));
        schurmat = schurmat(index,index);
    end
    
else
    % Manual version
    if p>0
    schurmatxx = zeros(p,p);
    for i = 1:p
        x = U*M{i};
       % Z = x(:)'*kron(V',speye(38))*MM;
        for j = i:p
            y = M{j}*V;
            schurmatxx(i,j) = x(:)'*y(:);
            schurmatxx(j,i) = schurmatxx(i,j);
        end
    end
    if min(xindicies)>max([Pindicies{:}])
        schurmat(schurmatindex(end):end,schurmatindex(end):end) = schurmatxx;
    else        
        if max(xindicies)<min([Pindicies{:}])
            schurmat = [schurmatxx schurmatxp';schurmatxp schurmat(1:ntot,1:ntot)];
        else
            error('Report bug (variables of non-structured variables have to defined before matrix variables')
%         elseif 0%min(xindicies)>max(Pindicies)
%             schurmat = [schurmat schurmatxp;schurmatxp' schurmatxx];
%         elseif 1
%             below = find(xindicies < Pindicies{1}(1));
%             above = find(xindicies > Pindicies{1}(end));
%             
%             schurmat = [schurmatxx(below,below) schurmatxp(:,below)' schurmatxx(below,above);
%                 schurmatxp(:,below) schurmat(1:ntot,1:ntot) schurmatxp(:,above);
%                 schurmatxx(above,below)  schurmatxp(:,above)' schurmatxx(above,above)];
%             
        end
    end
    end
end

nnzschur = nnzschurTEMP;
nzlistschur = nzlistschurTEMP;

function [Rit_U_Ri Rit_V_Ri Rit_U_Li Lit_U_Li Rit_V_Li Lit_V_Li] = precomputer_schur_same(U,V,Li,Ri)
U_Ri = U*Ri;
V_Ri = V*Ri;
U_Li = U*Li;
V_Li = V*Li;

Rit_U_Ri = Ri'*U_Ri;
Rit_V_Ri = Ri'*V_Ri;
Rit_U_Li = Ri'*U_Li;
Lit_U_Li = Li'*U_Li;
Rit_V_Li = Ri'*V_Li;
Lit_V_Li = Li'*V_Li;

function [Rit_U_Lj Rjt_V_Li Rit_U_Rj Ljt_V_Li Lit_U_Lj Rjt_V_Ri Lit_U_Rj Ljt_V_Ri] = precomputer_schur_different(U,V,Li,Lj,Ri,Rj)
U_Rj = U*Rj;
V_Ri = V*Ri;
U_Lj = U*Lj;
V_Li = V*Li;

Rit_U_Lj = Ri'*U_Lj;
Rjt_V_Li = Rj'*V_Li;
Rit_U_Rj = Ri'*U_Rj;
Ljt_V_Li = Lj'*V_Li;
Lit_U_Lj = Li'*U_Lj;
Rjt_V_Ri = Rj'*V_Ri;
Lit_U_Rj = Li'*U_Rj;
Ljt_V_Ri = Lj'*V_Ri;
function [AiUAit AiVAit] = precomputer_schur_same_disc(U,V,Ai)
AiUAit = Ai*U*Ai';
AiVAit = Ai*V*Ai';

function [AiUAjt AjVAit] = precomputer_schur_different_disc(U,V,Ai,Aj)
AiUAjt = Ai*U*Aj';
AjVAit = Aj*V*Ai';

function [A_U_R A_V_L A_V_R A_U_L] = precomputer_schur_mixed_disc(U,V,L,R,A)
A_U = A*U;
A_V = A*V;
A_U_R = A_U*R;
A_V_R = A_V*R;
A_U_L = A_U*L;
A_V_L = A_V*L;